stages:
  - build
  - test
  - release
  - deploy

build:
  stage: build
  image: node
  script:
    - echo "Start building App"
    - npm install
    - npm run build
    - echo "Build successfully!"
  cache:
    paths:
      - node_modules
  # artifacts:
  #   expire_in: 1 hour
  #   paths:
  #     - build
  #     - node_modules/

test:
  stage: test
  image: node
  script:
    - echo "Testing App"
    - npm install
    - CI=true npm run test
    - echo "Test successfully!"

docker-build:
  stage: release
  image: docker:latest
  services:
    - name: docker:19.03.8-dind
  before_script:
    - docker login -u "$CI_REGISTRY_USER" -p "$CI_REGISTRY_PASSWORD" $CI_REGISTRY
  script:
    - docker build --pull -t "$CI_REGISTRY_IMAGE" .
    - docker push "$CI_REGISTRY_IMAGE"

deploy:
  stage: deploy
  script:
    - 'which ssh-agent || (apt-get install -qq openssh-client)'
    - eval $(ssh-agent -s)
    - ssh-add <(echo "$SSH_PRIVATE_KEY")
    - mkdir -p ~/.ssh
    - '[[ -f /.dockerenv ]] && echo -e "Host *\n\tStrictHostKeyChecking no\n\n" > ~/.ssh/config'
    - ssh $SSH_HOST "$DEPLOY_CMD"
